/* rexec.h
**
** Interface file for `rexec.c'
** (check if a user has the permission to execute a command recipient.)
**
*/
#ifndef _REXEC_H
#define _REXEC_H

/* read the list of programs whom can be trusted enough that `vxdeliver'
** can execute one of them.
*/
int read_trusted (void);


/* check if a command has the permission to be executed by `vxdeliver'.
** I allow only program's in a special directory to be executed by
** `vxdeliver' - and only, if the execution of such a program is generally
** allowed.
*/
char *valid_prog (char *cmdline, uid_t *tuid, gid_t *tgid, int mf);

#endif /* defined(_REXEC_H) */
