#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>

#ifdef HAVE_GETRESUID
#define SDECL , suid, suid1
#define SFMT ", SUID = %d"
#define SPRT , suid
#define GETUIDs(euid,ruid,suid) getresuid(&(ruid),&(euid),&(suid))
#define SUID suid
#define SUID1 suid1
#define SCMP suid == suid1
#else
#define SDECL
#define SFMT
#define SPRT
#define GETUIDs(euid,ruid,suid) \
	    do { (euid) = geteuid(); (ruid) = getuid(); } while(0)
#define SUID
#define SUID1
#define SCMP 0
#endif

int main (int argc, char *argv[])
{
    pid_t pid;
    uid_t euid, euid1, ruid, ruid1 SDECL;
    int cldstat;
    if (geteuid() == 0) {
	ruid = geteuid(); euid = getuid();
	setuid (ruid); seteuid (euid);
    }
    GETUIDs(euid,ruid,SUID);
    switch (pid = fork ()) {
	case -1: /* error */
	    fprintf (stderr, "%s: couldn't fork(): %s\n",
			     argv[0],
			     strerror (errno));
	    exit (-1);
	case 0:  /* child */
	    GETUIDs(euid1,ruid1,SUID1);
	    if (ruid != ruid1 || euid != euid1 || SCMP) {
		exit (1);
	    }
/*	    printf ("in Child : UID = %d, EUID = %d" SFMT "\n", ruid, euid SPRT);*/
	    break;
	default: /* parent */
/*	    printf ("in Parent: UID = %d, EUID = %d" SFMT "\n", ruid, euid SPRT);*/
	    sleep (2);
	    wait (&cldstat);
	    if (WIFEXITED(cldstat)) { return WEXITSTATUS(cldstat); }
	    break;
    }
    return 0;
}
